package com.sxtvs.open.api.news.controller;

import com.sxtvs.open.api.news.dto.HotRankDTO;
import com.sxtvs.open.api.news.entity.HotRank;
import com.sxtvs.open.api.news.service.impl.HotRankServiceImpl;
import com.sxtvs.open.core.auth.LoginRequired;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-02-21
 */
@RestController
@RequestMapping("/news/hotRank")
public class HotRankController {

    @Resource
    private HotRankServiceImpl hotRankService;

    @RequestMapping("list")
    @LoginRequired
    public List<HotRankDTO> rank(@RequestParam(value = "province", required = false, defaultValue = "") String province){
        return hotRankService.todayRank(province);
    }
}
