package com.sxtvs.open.api.news.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sxtvs.open.api.news.dto.DataRequestDTO;
import com.sxtvs.open.api.news.entity.YoumeiData;
import com.sxtvs.open.api.news.entity.YoumeiEsData;
import com.sxtvs.open.api.news.service.impl.YoumeiDataServiceImpl;
import com.sxtvs.open.core.auth.LoginRequired;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author syj
 * @since 2023-02-20
 */
@RestController
@RequestMapping("/news/data")
public class YoumeiDataController {

    @Resource
    private YoumeiDataServiceImpl youmeiDataService;

    @RequestMapping("search")
    @LoginRequired
    public Page<YoumeiEsData> search(@RequestBody DataRequestDTO dataRequestDTO) throws Exception {
        return youmeiDataService.search(dataRequestDTO);
    }

    @RequestMapping("/put/MWEZOWQ2NDYXMJU0NW")
    public void put2es(){
        youmeiDataService.putDataRun();
    }

    @RequestMapping("category")
    public List<String> category(){
        return Arrays.asList("时政", "财经", "教育", "科技", "社会",  "体育", "游戏", "股票", "娱乐", "时尚", "彩票", "房产", "星座");
    }
}
