package com.sxtvs.open.api.news.service.impl;

import com.sxtvs.open.api.news.dto.HotRankDTO;
import com.sxtvs.open.api.news.entity.HotRank;
import com.sxtvs.open.api.news.mapper.HotRankMapper;
import com.sxtvs.open.api.news.service.IHotRankService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.http.util.TextUtils;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2023-02-21
 */
@Service
public class HotRankServiceImpl extends ServiceImpl<HotRankMapper, HotRank> implements IHotRankService {

    public List<HotRankDTO> todayRank(String province){
        String dt = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMMdd"));

        if(TextUtils.isEmpty(province)){
            return lambdaQuery().eq(HotRank::getDt, dt).eq(HotRank::getRankName, "密度-头条热榜").orderByAsc(HotRank::getRk)
                    .last("limit 20").list().stream().map(HotRankDTO::new).collect(Collectors.toList());
        }else{
            return lambdaQuery().eq(HotRank::getDt, dt).eq(HotRank::getRankName,province).eq(HotRank::getPlatform, "地域热点")
                    .orderByAsc(HotRank::getRk).last("limit 10").list().stream().map(HotRankDTO::new).collect(Collectors.toList());
        }
    }
}
